// Attract-Mode Front-End - "Shuffle" - FrizzleFried
// Visit my home arcade blogsite - www.idahogaragecade.com
// Created for my Capcom Anthology arcade cabinet using ARpiCADE

// Layout options

class UserConfig
{ 
</ label="Text or Logo Speed", help="Toggle advanced text or logo games list speed",options="Fastest,Fast,Medium,Slow,Slowest", order=1 /> glspeed="Medium";
</ label="Animated or Static Marquee", help="Toggle between animated and static marquee images.",options="Animated,Static", order=2 /> marq="Animated";
}
local my_config = fe.get_config();

// Set up art and text elements

fe.layout.width = 720;
fe.layout.height = 480;
fe.layout.font = "captain"
fe.do_nut( "scripts/animate.nut");

// Configurable Game List - uses the Conveyor_Helper module by ArcadeBliss (http://forum.attractmode.org/index.php?topic=1945.0)

fe.do_nut( "scripts/conveyor_helper.nut" );

	local glist = MyGameList();

		glist.type = ch.Coverflow; 							// OPTIONS: ch.Spinwheel / ch.Linear_Vertical / ch.Linear_Horizontal
		glist.bend.direction = ch.Right;					// OPTIONS: ch.Left / ch.Right
		glist.bend.gl_radius = 0
		glist.x = 360;										// OPTIONS: top left x-coordinate if gamelist is linear or the center x-coordinate if a spinwheel
		glist.y = 188;										// OPTIONS: top left y-coordinate if gamelist is linear or the center y-coordinate if a spinwheel
		glist.width = 720; 									// OPTIONS: linear game list total width in pixels
		glist.height = 240; 								// OPTIONS: linear list's height in pixels
	if ( my_config["glspeed"] == "Fastest" )
	{
		glist.ms_speed = 40;								// OPTIONS: in milliseconds, sets the speed of the conveyor
	}
	if ( my_config["glspeed"] == "Fast" )
	{
		glist.ms_speed = 100;								// OPTIONS: in milliseconds, sets the speed of the conveyor
	}
	if ( my_config["glspeed"] == "Medium" )
	{
		glist.ms_speed = 150;								// OPTIONS: in milliseconds, sets the speed of the conveyor
	}
	if ( my_config["glspeed"] == "Slow" )
	{
		glist.ms_speed = 225;								// OPTIONS: in milliseconds, sets the speed of the conveyor
	}
	if ( my_config["glspeed"] == "Slowest" )
	{
		glist.ms_speed = 300;								// OPTIONS: in milliseconds, sets the speed of the conveyor
	}		
	
	glist.fade_after_nav = 255;							// OPTIONS: 0-255 Fades the entire gamelist's alpha channel after navigation to this value. set to 255 to disable fading
	glist.fade_delay = 5000; 							// the amount of time in milliseconds before the fade should start
	glist.fade_speed = 5.0; 							// the mulitplier controlling the speed of the fade
	glist.fade_selected = false;					 	// OPTIONS: TRUE/FALSE fade selected game if gamelist fading is active
		
	glist.linear.padding = 15;								// the amount of padding in pixels between each gamelist item
	
	glist.item.contentTemplate = ch.Artwork;				// OPTIONS: ch.Artwork / ch.Text / ch.Artwork_and_Text / ch.Artwork_or_Text / ch.Flyer_and_Artwork 
	glist.item.count = 5; 									// OPTIONS: Total number of gamelist items to display
       
	glist.item.sizeScaling.low = 1.0; 						// OPTIONS: 0-100 Scaling size percentage to use for the item furthest from the selected item 
	glist.item.sizeScaling.high = 1.0; 					// OPTIONS: 0-100 Scaling size percentage to use for item closest to the selected item
	glist.item.sizeScaling.currentlySelected = 1.00;		// OPTIONS: 0-100 Scaling size percentage to use for the currently selected item
       
	glist.item.alphaScaling.low = 150; 						// OPTIONS: 0-100 Scaling size percentage to use for the item furthest from the selected item 
	glist.item.alphaScaling.high = 150; 					// OPTIONS: 0-100 Scaling size percentage to use for item closest to the selected item
	glist.item.alphaScaling.currentlySelected = 255;		// OPTIONS: 0-100 Scaling size percentage to use for the currently selected item
       
	glist.item.height = 260; 								// OPTIONS: Height of each gameList item in pixels before scaling - dynamic with linear vertical lists
	glist.item.width = 347;									// OPTIONS: Width of each gameList item in pixels before scaling - dynamic with linear horizontal lists
       	
	glist.item.margin.left = 0; 							// OPTION: bounding box left margin size for all images and text 
	glist.item.margin.right = 0; 							// OPTION: bounding box right margin size for all images and text
	glist.item.margin.top = 0;								// OPTION: bounding box top margin size for all images and text
	glist.item.margin.bottom = 0;							// OPTION: bounding box bottom margin size for all images and text
      
	glist.item.toggle.backgroundColor = false;				// if set to "TRUE" the game item background can be colored (use item.normal.color)
	glist.item.toggle.backgroundFile = false;				// if set to "TRUE" the game item will use a file as the background (file: item_backgroundFile.png)
	glist.item.toggle.selectedBackgroundColor = false; 		// if set to "TRUE" the selected game item background can be colored (use item.currentlySelected.color)
	glist.item.toggle.selectedBackgroundFile = false;		// if set to "TRUE" the selected game item will use a file as the background (file: item_selectedBackgroundFile.png)
	glist.item.toggle.glossOverlay = false;					// if set to "TRUE" will overlay the game item with a gloss file (file: item_glossOverlay.png)
	glist.item.toggle.borderOverlay = false;				// if set to "TRUE" will overlay the game item with a boarder file (file: item_borderOverlay.png)
			
	glist.item.normal.color.red = 0;						// OPTIONS: background red color channel 0 - 255
	glist.item.normal.color.green = 255;               		// OPTIONS: background green color channel 0 - 255
	glist.item.normal.color.blue = 255;                		// OPTIONS: background blue color channel 0 - 255
       
	glist.item.currentlySelected.color.red=0;				// OPTIONS: background red color channel 0 - 255
	glist.item.currentlySelected.color.green=128;      		// OPTIONS: background green color channel 0 - 255
	glist.item.currentlySelected.color.blue=128;       		// OPTIONS: background blue color channel 0 - 255
             
	glist.artwork.type = "snap"; 							// OPTIONS: name of the artwork to use for the conveyour
	glist.artwork.type2 = "snap";							// OPTIONS: name of the artwork to use for the conveyour setting "Flyer_and_Artwork"
	glist.artwork.preserveAspect = true;					// OPTIONS: true / false
		
	glist.show();

// Marquee	
	
if ( my_config["marq"] == "Animated" )
	{
	local mmarquee = fe.add_artwork( "marquee", 160, 335, 402, 125 );
	local mmarquee_scale_cfg = {
		when =Transition.ToNewSelection,
		property = "scale",
		start = 0.5,
		end = 1.0,
		time = 1000,
		tween = Tween.Bounce,
	}
	animation.add( PropertyAnimation( mmarquee, mmarquee_scale_cfg ) );
	}
if ( my_config["marq"] == "Static" )
	{
	fe.add_artwork( "marquee", 160, 335, 402, 125 );
	}
	
// Background

fe.add_image( "glbg.png", 0, 0, 720, 480 );

local gamenum = fe.add_text("[ListEntry] / [ListSize] ",80,8,136,30);
	gamenum.set_rgb( 0, 0, 0 );
local gamenum = fe.add_text("[ListEntry] / [ListSize] ",82,10,136,30);
	gamenum.set_rgb( 255, 255, 255 );

// Text Bits	
	
local year = fe.add_text("[Year]",540,8,80,30);
	year.set_rgb( 0, 0, 0 );
local year = fe.add_text("[Year]",542,10,80,30);
	year.set_rgb( 255, 255, 255 );

local manuf = fe.add_text("[Manufacturer]",200,8,320,30);
	manuf.set_rgb( 0, 0, 0 );
local manuf = fe.add_text("[Manufacturer]",202,10,320,30);
	manuf.set_rgb( 255, 255, 255 );	
	
// Game select sound

function select_sound( ttype, var, ttime ) {
 switch ( ttype ) {

  case Transition.ToNewSelection:
	      local sound = fe.add_sound("glclick.mp3");
	      sound.playing=true;
  break;
  }
 return false;
}
fe.add_transition_callback( "select_sound" );